#include<Alert.h>
#include<Application.h>
#include<Path.h>

#include"listview.h"
#include"myWindow.h"
#include"app.h"

extern myatfApp * atfApp;

extern BList * allTypesList;
extern BList * activeTypesList;
extern BList * inactiveTypesList;

#include<iostream>

myWindow::myWindow()
		: BWindow( BRect(100, 40, 550, 600), "AttributesToFile", B_TITLED_WINDOW, 
			B_NOT_RESIZABLE | B_NOT_ZOOMABLE, B_CURRENT_WORKSPACE )
{
	atfView = new BView(Bounds(), "mainView", B_FOLLOW_ALL_SIDES, 
					B_WILL_DRAW | B_FULL_UPDATE_ON_RESIZE);
					
	rgb_color bgColor = ui_color(B_PANEL_BACKGROUND_COLOR);
	atfView->SetViewColor(bgColor);
	AddChild(atfView);

/*  The upper BBox containing the BListViews */
	listsBox = new BBox( BRect(5, 10, 445, 265), "listsBox", B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW, B_FANCY_BORDER);
	listsBox->SetLabel("Step 1: Choose the attributes you want to be listed in the file");
	atfView->AddChild(listsBox);


	actListStrView = new BStringView( BRect(5, 20, 150, 30), "aListStringView", "Attributes to be listed:", B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW );
	listsBox->AddChild(actListStrView);

	inactListStrView = new BStringView( BRect(265, 20, 390, 30), "iListStringView", "Deactivated attributes:", B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW );
	listsBox->AddChild(inactListStrView);


	activeListView = new myListView( BRect(5, 35, 135, 240), "activeList");

	inactiveListView = new myListView( BRect(265, 35, 395, 240), "inactiveList");

	listsBox->AddChild(inactiveListView);

/*	scrView = new BScrollView("scroll_ALView", activeListView, 
		B_FOLLOW_LEFT | B_FOLLOW_TOP, 0, false, true, B_FANCY_BORDER);
	listsBox->AddChild(scrView);
*/

	listsBox->AddChild(activeListView);
	activeListView->SetInvocationMessage( new BMessage(ACTIVE_INVOC_MSG) );

	aListBar = new BScrollBar( BRect(135, 35, 135 + B_V_SCROLL_BAR_WIDTH, 240),
					"aListBar", activeListView, 1.0, 1.0, B_VERTICAL);
					
	iListBar = new BScrollBar( BRect(395, 35, 395 + B_V_SCROLL_BAR_WIDTH, 240),
					"iListBar", inactiveListView, 1.0, 1.0, B_VERTICAL);
	
	listsBox->AddChild(aListBar);
	listsBox->AddChild(iListBar);

	for (int i = 0 ; i < allTypesList->CountItems() ; i++)
	{
		activeListView->AddItem( new BStringItem ( ((BString *) allTypesList->ItemAt(i))->String() ) );
	}


	actButton = new BButton( BRect(170, 40, 250, 60), "actButton", "<< Enable", new BMessage(BTN_ACT_MSG) );
	listsBox->AddChild(actButton);

	deactButton = new BButton( BRect(170, 80, 250, 100), "deactButton", "Disable >>", new BMessage(BTN_DEACT_MSG) );
	listsBox->AddChild(deactButton);

	toggleButton = new BButton( BRect(170, 120, 250, 140), "toggleButton", "Toggle", new BMessage(BTN_TOGGLE_MSG) );
	listsBox->AddChild(toggleButton);


	optsBox = new BBox( BRect(5, 280, 445, 470), "optionsBox", B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW, B_FANCY_BORDER);
	optsBox->SetLabel("Step 2: Choose the output details");
	atfView->AddChild(optsBox);

	formatBox = new BBox( BRect(5, 20, 435, 100), "formatBox", B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW, B_FANCY_BORDER);
	formatBox->SetFont(be_plain_font);
	formatBox->SetLabel("Output Format:");
	optsBox->AddChild(formatBox);

	csvRBtn = new BRadioButton( BRect(10, 20, 100, 40), "csvRBtn", "CSV format", new BMessage(RBTN_CSV_MSG) );
	csvRBtn->SetValue(B_CONTROL_ON);

	sepCharsTxtCtrl = new BTextControl( BRect(100, 10, 280, 30), "sepCharsTxtCtrl", "Separating character(s): ", "", new BMessage(TXTCTRL_SEPCHARS_MSG) );
	sepCharsTxtCtrl->SetDivider(130.0);
	formatBox->AddChild(sepCharsTxtCtrl);

	BStringView * sepCharsHelpStrView = new BStringView( BRect(285, 10, 405, 25), "sepCharsExplanation", "(leave empty to use TAB)", B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW);
	formatBox->AddChild(sepCharsHelpStrView);

	BStringView * emptyCharsHelpStrView = new BStringView( BRect(285, 30, 420, 45), "emptyCharsExplanation", "(leave empty to use SPACE)", B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW);
	formatBox->AddChild(emptyCharsHelpStrView);

	emptyCharsTxtCtrl = new BTextControl( BRect(100, 30, 280, 50), "emptyCharsTxtCtrl", "Empty fields' character(s): ", "", new BMessage(TXTCTRL_EMPTYCHARS_MSG) );
	emptyCharsTxtCtrl->SetDivider(130.0);
	formatBox->AddChild(emptyCharsTxtCtrl);


	htmlRBtn = new BRadioButton( BRect(10, 50, 100, 70), "htmlRBtn", "HTML table", new BMessage(RBTN_HTML_MSG), B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
	formatBox->AddChild(csvRBtn);
	formatBox->AddChild(htmlRBtn);


	listFilenamesCBox = new BCheckBox ( BRect(10, 115, 200, 135), "listFilenamesCBox", "List filenames?", new BMessage(CHECKBOX_FILENAME_MSG), B_FOLLOW_LEFT | B_FOLLOW_TOP,
								B_WILL_DRAW | B_NAVIGABLE );
	optsBox->AddChild(listFilenamesCBox);
	listFilenamesCBox->SetValue(B_CONTROL_ON);


	outfileTxtCtrl = new BTextControl( BRect(10, 140, 350, 160), "outfileTxtCtrl", "Specify Outfile:", "", new BMessage(TXTCTRL_OUTF_MSG) );
	outfileTxtCtrl->SetDivider(80.0);
	outfileTxtCtrl->SetText( atfApp->Outfilepath.Path() );
	optsBox->AddChild(outfileTxtCtrl);
	

	browseButton = new BButton( BRect(360, 137, 420, 162), "browseButton", "Browse", new BMessage(BTN_BROWSE_MSG) );
	optsBox->AddChild(browseButton);
	

	goBox = new BBox( BRect(5, 480, 445, 520), "formatBox", B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW, B_FANCY_BORDER);
	atfView->AddChild(goBox);
	goBox->SetFont(be_bold_font);
	goBox->SetLabel("Step 3: Begin!");

	goButton = new BButton( BRect(160, 10, 260, 30), "goButton", "Go!", new BMessage(BTN_GO_MSG) );
	goBox->AddChild(goButton);
	goButton->MakeFocus();


	aboutButton = new BButton( BRect(165, 530, 215, 550), "aboutButton", "About ...", new BMessage(BTN_ABOUT_MSG) );
	atfView->AddChild(aboutButton);

	helpButton = new BButton( BRect(220, 530, 265, 550), "helpButton", "Help ...", new BMessage(BTN_HELP_MSG) );
	atfView->AddChild(helpButton);
}


myWindow::~myWindow()
{

}


void myWindow::MessageReceived( BMessage *message)
{
	BFilePanel *fOutfilePanel;
	BDirectory saveDir;
	BEntry dirEntry;
	BPath savePath;
	entry_ref dirRef;
	const char * filename;

	switch (message->what)
	{
		case ACTIVE_INVOC_MSG :
			cout << "Item was invoked\n";
			(new BAlert("invoc_alert", "Item was invoked", "Ok", NULL, NULL, B_WIDTH_AS_USUAL, B_INFO_ALERT))->Go();
			break;

		case BTN_ABOUT_MSG:
			atfApp->AboutRequested();
			break;

		case BTN_ACT_MSG :
			for (int32 i = 0; i < inactiveListView->CountItems(); i++)
			{
				if (inactiveListView->IsItemSelected(i)==true) 
				{
					activeListView->AddItem(inactiveListView->ItemAt(i));
					inactiveListView->RemoveItem(i);
					i=-1;
				}
			}
			break;

		case BTN_BROWSE_MSG :

			fOutfilePanel = new BFilePanel(	B_SAVE_PANEL, new BMessenger(this), NULL, B_FILE_NODE,
									false, new BMessage(FILEPANEL_OUTF_MSG), NULL, false, true);
			fOutfilePanel -> Show();
			break;

		case BTN_DEACT_MSG :
			for (int32 i = 0; i < activeListView->CountItems();i++)
			{
				if (activeListView->IsItemSelected(i) == true) 
				{
					inactiveListView->AddItem(activeListView->ItemAt(i));
					activeListView->RemoveItem(i);
					i=-1;
				}
			}
			break;

		case BTN_GO_MSG:

			// Write content of activeListView into activeTypesList
			int count;
			for (count = 0; count<activeListView->CountItems(); count++)
			{
				activeTypesList->AddItem( (  new BString(    ((BStringItem *) activeListView->ItemAt(count) )->Text()   ) ) );
			}

			atfApp->CopyFilenamesToVector();
			atfApp->CopyAttributesToVector();

			if (strcmp(emptyCharsTxtCtrl->Text(), "") != 0)
			{ 
				atfApp->emptyChars.SetTo( emptyCharsTxtCtrl->Text() );
			}

			if (strcmp(sepCharsTxtCtrl->Text(), "") != 0)
			{ 
				atfApp->separatorChars.SetTo( sepCharsTxtCtrl->Text() );
			}

			atfApp->listFilenames = listFilenamesCBox->Value();

			atfApp->CopyVectorToOutfile();

		 	be_app->PostMessage(B_QUIT_REQUESTED, this);
			be_app->PostMessage(B_QUIT_REQUESTED, be_app); 
			break;

		case BTN_HELP_MSG :
			atfApp->Help();
			break;

		case BTN_TOGGLE_MSG :	
			if ( activeListView->CountItems() != 0)
			{
				for (int32 i=0; i<activeListView->CountItems();i++)
				{
					inactiveListView->AddItem(activeListView->ItemAt(i));
					activeListView->RemoveItem(i);
					i=-1;
				}
			}
			else 
			{
				for (int32 i=0; i<inactiveListView->CountItems();i++)
				{
					activeListView->AddItem(inactiveListView->ItemAt(i));
					inactiveListView->RemoveItem(i);
					i=-1;
				}
			}
			break;

		case CHECKBOX_FILENAME_MSG:
			break;		

		case FILEPANEL_OUTF_MSG : 

			message->FindRef("directory", &dirRef);
			message->FindString("name", &filename);

			saveDir.SetTo(&dirRef);
			saveDir.GetEntry(&dirEntry);
			dirEntry.GetPath(&savePath);
				
			atfApp->outfileName.SetTo(savePath.Path());
			atfApp->outfileName.Append("/", strlen("/"));
			atfApp->outfileName.Append(filename, strlen(filename));

			atfApp->Outfilepath.SetTo( atfApp->outfileName.String() );
			outfileTxtCtrl->SetText(atfApp->outfileName.String() );

			break;

		case RBTN_CSV_MSG :
			sepCharsTxtCtrl->SetEnabled(true);
			emptyCharsTxtCtrl->SetEnabled(true);
			atfApp->SetFormat(CSVFORMAT);
			break;

		case RBTN_HTML_MSG :
			sepCharsTxtCtrl->SetEnabled(false);
			emptyCharsTxtCtrl->SetEnabled(false);
			atfApp->SetFormat(HTMLFORMAT);
			break;

		case TXTCTRL_OUTF_MSG :
			atfApp->Outfilepath.SetTo( outfileTxtCtrl->Text() );
			break;

		case TXTCTRL_EMPTYCHARS_MSG:
			if (strcmp(emptyCharsTxtCtrl->Text(), "") != 0)
			{ 
				atfApp->emptyChars.SetTo( emptyCharsTxtCtrl->Text() );
			}
			break;

		case TXTCTRL_SEPCHARS_MSG:
			if (strcmp(sepCharsTxtCtrl->Text(), "") != 0)
			{ 
				atfApp->separatorChars.SetTo( sepCharsTxtCtrl->Text() );
			}
			break;

		default:
			{
			BWindow::MessageReceived(message);
			}
	}
}

bool myWindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED, be_app); 
	return (true);
}
