
#ifndef _MYWINDOW_H
#define _MYWINDOW_H


#include<interface/Box.h>
#include<interface/CheckBox.h>
#include<interface/Button.h>
#include<FilePanel.h>
#include<interface/ListView.h>
#include<interface/RadioButton.h>
#include<interface/ScrollBar.h>
#include<interface/ScrollView.h>
#include<support/String.h>
#include<interface/StringView.h>
#include<interface/TextControl.h>
#include<interface/View.h>
#include<interface/Window.h>


#include"listview.h"

// application specific messages 
#define BTN_GO_MSG 'btgo'
#define BTN_ACT_MSG 'btac'
#define BTN_DEACT_MSG 'btde'
#define BTN_TOGGLE_MSG 'btto'
#define BTN_ABOUT_MSG 'btab'
#define BTN_HELP_MSG 'bthe'
#define CHECKBOX_FILENAME_MSG 'chfi'
#define RBTN_CSV_MSG 'btcs'
#define RBTN_HTML_MSG 'btht'
#define TXTCTRL_CHAR_MSG 'tcch'
#define TXTCTRL_OUTF_MSG 'tcof'
#define TXTCTRL_SEPCHARS_MSG 'tcsc'
#define TXTCTRL_EMPTYCHARS_MSG 'tcec'
#define BTN_BROWSE_MSG 'btbr'
#define FILEPANEL_OUTF_MSG 'fpof'
#define ACTIVE_INVOC_MSG 'ainv'


class myWindow : public BWindow
{
public:
					myWindow();
					~myWindow();
	virtual void	MessageReceived (BMessage* message);
	virtual bool	QuitRequested();
	
			void	ChangeText(const char * text);
	
/* GUI stuff */
					BBox * goBox;
					BBox * listsBox;
					BBox * optsBox;
					BBox * formatBox;

					BButton * actButton;
					BButton * deactButton;
					BButton * toggleButton;

					BButton * aboutButton;
					BButton * browseButton;
					BButton * goButton;
					BButton * helpButton;

					BCheckBox * rawCBox;
					BCheckBox * pathCBox;
					BCheckBox * listFilenamesCBox;
					BFilePanel * fOutfilePanel;

					myListView * activeListView;
					myListView * inactiveListView;
					BStringView * actListStrView;
					BStringView * inactListStrView;

					BRadioButton * csvRBtn;
					BRadioButton * htmlRBtn;

					BScrollBar * aListBar;
					BScrollBar * iListBar;
					BScrollView * scrView;
					
					BStringItem * item;
					BStringView * step3View;

					BTextControl * sepCharsTxtCtrl;
					BTextControl * emptyCharsTxtCtrl;
					BTextControl * outfileTxtCtrl;

					BView * atfView;

					int listelements;
};

#endif
